diff -urN ../VisualBoyAdvance-1.7.2/src/win32/MapView.cpp ./src/win32/MapView.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/MapView.cpp	2004-05-13 23:21:38 +0900
+++ ./src/win32/MapView.cpp	2006-06-07 06:04:21 +0900
@@ -1,6 +1,6 @@
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -465,6 +465,7 @@
   bg = 2;
 }
 
+
 void MapView::OnRefresh() 
 {
   paint();  
@@ -511,6 +512,12 @@
   case 5:
     renderMode5();
     break;
+  case 6:
+    renderMode5();
+    break;
+  case 7:
+    renderMode5();
+    break;
   }
   enableButtons(mode);
   SIZE s;
@@ -759,7 +766,7 @@
   u32 base = ((control >> 8) & 0x1f) * 0x800 + 0x6000000;
   
   // all text bgs (16 bits)
-  if(mode == 0 ||(mode < 3 && bg < 2)) {
+  if(mode == 0 ||(mode < 3 && bg < 2) || mode == 6 || mode == 7) {
     return GetTextClickAddress(base, x, y);
   }
   // rot bgs (8 bits)
@@ -779,8 +786,8 @@
   u8 *colors = (u8 *)lParam;
   mapViewZoom.setColors(colors);
 
-  int x = wParam & 0xffff;
-  int y = (wParam >> 16);
+  int x = (int)(wParam & 0xffff);
+  int y = (int)(wParam >> 16);
   
   CString buffer;
   buffer.Format("(%d,%d)", x, y);
@@ -791,7 +798,7 @@
   GetDlgItem(IDC_ADDRESS)->SetWindowText(buffer);
 
   int mode = DISPCNT & 7;  
-  if(mode >= 3) {
+  if(mode >= 3 && mode <=5) {
     // bitmap modes
     GetDlgItem(IDC_TILE_NUM)->SetWindowText("---");
     GetDlgItem(IDC_FLIP)->SetWindowText("--");
@@ -991,36 +998,39 @@
   fclose(fp);
 }
 
-void MapView::OnSave() 
+void MapView::OnSave()
 {
-  CString filename;
+  if(rom != NULL)
+  {
+    CString filename;
+
+    if(theApp.captureFormat == 0)
+      filename = "map.png";
+    else
+      filename = "map.bmp";
+
+    LPCTSTR exts[] = {".png", ".bmp" };
+
+    CString filter = theApp.winLoadFilter(IDS_FILTER_PNG);
+    CString title = winResLoadString(IDS_SELECT_CAPTURE_NAME);
+
+    FileDlg dlg(this,
+                filename,
+                filter,
+                theApp.captureFormat ? 2 : 1,
+                theApp.captureFormat ? "BMP" : "PNG",
+                exts,
+                "",
+                title,
+                true);
 
-  if(theApp.captureFormat == 0)
-    filename = "map.png";
-  else
-    filename = "map.bmp";
-
-  LPCTSTR exts[] = {".png", ".bmp" };
-
-  CString filter = theApp.winLoadFilter(IDS_FILTER_PNG);
-  CString title = winResLoadString(IDS_SELECT_CAPTURE_NAME);
-
-  FileDlg dlg(this,
-              filename,
-              filter,
-              theApp.captureFormat ? 2 : 1,
-              theApp.captureFormat ? "BMP" : "PNG",
-              exts,
-              "",
-              title,
-              true);
+    if(dlg.DoModal() == IDCANCEL) {
+      return;
+    }
 
-  if(dlg.DoModal() == IDCANCEL) {
-    return;
+    if(dlg.getFilterIndex() == 2)
+      saveBMP(dlg.GetPathName());
+    else
+      savePNG(dlg.GetPathName());
   }
-
-  if(dlg.getFilterIndex() == 2)
-    saveBMP(dlg.GetPathName());
-  else
-    savePNG(dlg.GetPathName());
 }
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/MapView.h ./src/win32/MapView.h
--- ../VisualBoyAdvance-1.7.2/src/win32/MapView.h	2004-05-13 22:38:49 +0900
+++ ./src/win32/MapView.h	2006-05-27 23:47:33 +0900
@@ -31,7 +31,7 @@
 #include "ZoomControl.h"
 #include "ResizeDlg.h"
 #include "IUpdate.h"
-#include "..\System.h"  // Added by ClassView
+#include "../System.h"  // Added by ClassView
 
 /////////////////////////////////////////////////////////////////////////////
 // MapView dialog
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/MemoryViewer.cpp ./src/win32/MemoryViewer.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/MemoryViewer.cpp	2004-05-13 23:21:13 +0900
+++ ./src/win32/MemoryViewer.cpp	2006-05-27 23:47:33 +0900
@@ -535,8 +535,8 @@
 }
 
 LRESULT MemoryViewer::OnWMChar(WPARAM wParam, LPARAM LPARAM)
-{
-  if(OnEditInput(wParam))
+{ // The WM_CHAR message uses Unicode Transformation Format (UTF)-16.
+  if(OnEditInput((UINT)(wParam & 0xFFFF)))
     return 0;
   return 1;
 }
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/MemoryViewer.h ./src/win32/MemoryViewer.h
--- ../VisualBoyAdvance-1.7.2/src/win32/MemoryViewer.h	2004-05-13 22:38:21 +0900
+++ ./src/win32/MemoryViewer.h	2006-05-27 23:47:33 +0900
@@ -20,7 +20,7 @@
 #if !defined(AFX_MEMORYVIEWER_H__52C50474_5399_4D0B_A3E4_4C52C4E0EAA0__INCLUDED_)
 #define AFX_MEMORYVIEWER_H__52C50474_5399_4D0B_A3E4_4C52C4E0EAA0__INCLUDED_
 
-#include "..\System.h"  // Added by ClassView
+#include "../System.h"  // Added by ClassView
 #if _MSC_VER > 1000
 #pragma once
 #endif // _MSC_VER > 1000
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/MemoryViewerAddressSize.h ./src/win32/MemoryViewerAddressSize.h
--- ../VisualBoyAdvance-1.7.2/src/win32/MemoryViewerAddressSize.h	2004-05-13 22:38:09 +0900
+++ ./src/win32/MemoryViewerAddressSize.h	2006-05-27 23:47:33 +0900
@@ -20,7 +20,7 @@
 #if !defined(AFX_MEMORYVIEWERADDRESSSIZE_H__04605262_2B1D_4EED_A467_B6C56AC2CACD__INCLUDED_)
 #define AFX_MEMORYVIEWERADDRESSSIZE_H__04605262_2B1D_4EED_A467_B6C56AC2CACD__INCLUDED_
 
-#include "..\System.h"  // Added by ClassView
+#include "../System.h"  // Added by ClassView
 #if _MSC_VER > 1000
 #pragma once
 #endif // _MSC_VER > 1000
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/MemoryViewerDlg.cpp ./src/win32/MemoryViewerDlg.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/MemoryViewerDlg.cpp	2004-05-13 23:20:50 +0900
+++ ./src/win32/MemoryViewerDlg.cpp	2005-09-03 21:29:23 +0900
@@ -320,14 +320,59 @@
 
 void MemoryViewerDlg::OnSave() 
 {
-  MemoryViewerAddressSize dlg;
-  CString buffer;
+  if(rom != NULL)
+  {
+    MemoryViewerAddressSize dlg;
+    CString buffer;
 
-  dlg.setAddress(m_viewer.getCurrentAddress());
+    dlg.setAddress(m_viewer.getCurrentAddress());
 
-  LPCTSTR exts[] = { ".dmp" };
+    LPCTSTR exts[] = { ".dmp" };
   
-  if(dlg.DoModal() == IDOK) {
+    if(dlg.DoModal() == IDOK) {
+      CString filter = theApp.winLoadFilter(IDS_FILTER_DUMP);
+      CString title = winResLoadString(IDS_SELECT_DUMP_FILE);
+
+      FileDlg file(this,
+                   buffer,
+                   filter,
+                   0,
+                   "DMP",
+                   exts,
+                   "",
+                   title, 
+                   true);
+      if(file.DoModal() == IDOK) {
+        buffer = file.GetPathName();
+
+        FILE *f = fopen(buffer, "wb");
+      
+        if(f == NULL) {
+          systemMessage(IDS_ERROR_CREATING_FILE, buffer);
+          return;
+        }
+
+        int size = dlg.getSize();
+        u32 addr = dlg.getAddress();
+
+        for(int i = 0; i < size; i++) {
+          fputc(CPUReadByteQuick(addr), f);
+          addr++;
+        }
+
+        fclose(f);
+      }
+    }
+  }
+}
+
+void MemoryViewerDlg::OnLoad() 
+{
+  if(rom != NULL)
+  {
+    CString buffer;
+    LPCTSTR exts[] = { ".dmp" };
+
     CString filter = theApp.winLoadFilter(IDS_FILTER_DUMP);
     CString title = winResLoadString(IDS_SELECT_DUMP_FILE);
 
@@ -338,84 +383,45 @@
                  "DMP",
                  exts,
                  "",
-                 title, 
-                 true);
+                 title,
+                 false);
+  
     if(file.DoModal() == IDOK) {
       buffer = file.GetPathName();
-
-      FILE *f = fopen(buffer, "wb");
-      
+      FILE *f = fopen(buffer, "rb");
       if(f == NULL) {
-        systemMessage(IDS_ERROR_CREATING_FILE, buffer);
+        systemMessage(IDS_CANNOT_OPEN_FILE,
+                      "Cannot open file %s",
+                      buffer);
         return;
       }
-
-      int size = dlg.getSize();
-      u32 addr = dlg.getAddress();
-
-      for(int i = 0; i < size; i++) {
-        fputc(CPUReadByteQuick(addr), f);
-        addr++;
-      }
-
-      fclose(f);
-    }
-  }
-}
-
-void MemoryViewerDlg::OnLoad() 
-{
-  CString buffer;
-  LPCTSTR exts[] = { ".dmp" };
-
-  CString filter = theApp.winLoadFilter(IDS_FILTER_DUMP);
-  CString title = winResLoadString(IDS_SELECT_DUMP_FILE);
-
-  FileDlg file(this,
-               buffer,
-               filter,
-               0,
-               "DMP",
-               exts,
-               "",
-               title,
-               false);
-  
-  if(file.DoModal() == IDOK) {
-    buffer = file.GetPathName();
-    FILE *f = fopen(buffer, "rb");
-    if(f == NULL) {
-      systemMessage(IDS_CANNOT_OPEN_FILE,
-                    "Cannot open file %s",
-                    buffer);
-      return;
-    }
     
-    MemoryViewerAddressSize dlg;    
+      MemoryViewerAddressSize dlg;    
 
-    fseek(f, 0, SEEK_END);
-    int size = ftell(f);
+      fseek(f, 0, SEEK_END);
+      int size = ftell(f);
 
-    fseek(f, 0, SEEK_SET);
+      fseek(f, 0, SEEK_SET);
     
-    dlg.setAddress(m_viewer.getCurrentAddress());
-    dlg.setSize(size);
+      dlg.setAddress(m_viewer.getCurrentAddress());
+      dlg.setSize(size);
     
-    if(dlg.DoModal() == IDOK) {
-      int size = dlg.getSize();
-      u32 addr = dlg.getAddress();
-
-      for(int i = 0; i < size; i++) {
-        int c = fgetc(f);
-        if(c == -1)
-          break;
-        CPUWriteByteQuick(addr, c);
-        addr++;
+      if(dlg.DoModal() == IDOK) {
+        int size = dlg.getSize();
+        u32 addr = dlg.getAddress();
+
+        for(int i = 0; i < size; i++) {
+          int c = fgetc(f);
+          if(c == -1)
+            break;
+          CPUWriteByteQuick(addr, c);
+          addr++;
+        }
+        OnRefresh();
       }
-      OnRefresh();
+      fclose(f);    
     }
-    fclose(f);    
-  }  
+  }
 }
 
 void MemoryViewerDlg::PostNcDestroy() 
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/ModeConfirm.cpp ./src/win32/ModeConfirm.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/ModeConfirm.cpp	2004-05-13 23:20:38 +0900
+++ ./src/win32/ModeConfirm.cpp	2006-06-07 06:04:21 +0900
@@ -100,7 +100,7 @@
                 // EXCEPTION: OCX Property Pages should return FALSE
 }
 
-void ModeConfirm::OnTimer(UINT nIDEvent) 
+void ModeConfirm::OnTimer(UINT_PTR nIDEvent) 
 {
   CString buffer;  
   count--;
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/ModeConfirm.h ./src/win32/ModeConfirm.h
--- ../VisualBoyAdvance-1.7.2/src/win32/ModeConfirm.h	2004-05-13 22:37:41 +0900
+++ ./src/win32/ModeConfirm.h	2006-06-07 06:04:21 +0900
@@ -34,7 +34,7 @@
   // Construction
  public:
   int count;
-  UINT timer;
+  UINT_PTR timer;
   ModeConfirm(CWnd* pParent);   // standard constructor
 
   // Dialog Data
@@ -60,7 +60,7 @@
   afx_msg void OnOk();
   afx_msg void OnDestroy();
   virtual BOOL OnInitDialog();
-  afx_msg void OnTimer(UINT nIDEvent);
+  afx_msg void OnTimer(UINT_PTR nIDEvent);
   //}}AFX_MSG
   DECLARE_MESSAGE_MAP()
     };
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/OamView.cpp ./src/win32/OamView.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/OamView.cpp	2004-05-13 23:20:26 +0900
+++ ./src/win32/OamView.cpp	2005-09-03 21:29:23 +0900
@@ -463,37 +463,40 @@
 
 void OamView::OnSave() 
 {
-  CString captureBuffer;
-
-  if(theApp.captureFormat == 0)
-    captureBuffer = "oam.png";
-  else
-    captureBuffer = "oam.bmp";
-
-  LPCTSTR exts[] = {".png", ".bmp" };
-
-  CString filter = theApp.winLoadFilter(IDS_FILTER_PNG);
-  CString title = winResLoadString(IDS_SELECT_CAPTURE_NAME);
-
-  FileDlg dlg(this,
-              captureBuffer,
-              filter,
-              theApp.captureFormat ? 2 : 1,
-              theApp.captureFormat ? "BMP" : "PNG",
-              exts,
-              "",
-              title,
-              true);
-
-  if(dlg.DoModal() == IDCANCEL) {
-    return;
+  if(rom != NULL)
+  {
+    CString captureBuffer;
+
+    if(theApp.captureFormat == 0)
+      captureBuffer = "oam.png";
+    else
+      captureBuffer = "oam.bmp";
+
+    LPCTSTR exts[] = {".png", ".bmp" };
+
+    CString filter = theApp.winLoadFilter(IDS_FILTER_PNG);
+    CString title = winResLoadString(IDS_SELECT_CAPTURE_NAME);
+
+    FileDlg dlg(this,
+                captureBuffer,
+                filter,
+                theApp.captureFormat ? 2 : 1,
+                theApp.captureFormat ? "BMP" : "PNG",
+                exts,
+                "",
+                title,
+                true);
+
+    if(dlg.DoModal() == IDCANCEL) {
+      return;
+    }
+    captureBuffer = dlg.GetPathName();
+
+    if(dlg.getFilterIndex() == 2)
+      saveBMP(captureBuffer);
+    else
+      savePNG(captureBuffer); 
   }
-  captureBuffer = dlg.GetPathName();
-
-  if(dlg.getFilterIndex() == 2)
-    saveBMP(captureBuffer);
-  else
-    savePNG(captureBuffer);  
 }
 
 BOOL OamView::OnInitDialog() 
